"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.onHistoryPush = onHistoryPush;
exports.SwitchContext = exports.default = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _reactRouter = require("react-router");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const SwitchContext = (0, _react.createContext)();
exports.SwitchContext = SwitchContext;
const historyPushHandlers = [];

function onHistoryPush(handleHistoryPush) {
  const index = historyPushHandlers.length;
  historyPushHandlers.push(handleHistoryPush);
  return {
    remove: () => delete historyPushHandlers[index]
  };
}

class Switch extends _react.Component {
  componentWillMount() {
    const router = this.context.router;
    const history = router.history;

    if (!history._push) {
      history._push = history.push;

      history.push =
      /*#__PURE__*/
      function () {
        var _ref = _asyncToGenerator(function* (...args) {
          for (var _i = 0; _i < historyPushHandlers.length; _i++) {
            const handleHistoryPush = historyPushHandlers[_i];

            if (typeof handleHistoryPush === 'function') {
              yield handleHistoryPush(router, ...args);
            }
          }

          history._push(...args);
        });

        return function () {
          return _ref.apply(this, arguments);
        };
      }();
    }
  }

  render() {
    const props = _objectSpread({}, this.props);

    delete props.loading;
    delete props.loadingAll;
    return _react.default.createElement(SwitchContext.Provider, {
      value: {
        loading: this.props.loading,
        loadingAll: this.props.loadingAll,
        onLoadingFinish: this.props.onLoadingFinish,
        onLoadingStart: this.props.onLoadingStart
      }
    }, _react.default.createElement(_reactRouter.Switch, props, this.props.children));
  }

}

exports.default = Switch;

_defineProperty(Switch, "propTypes", {
  loading: _propTypes.default.node,
  loadingAll: _propTypes.default.bool,
  onLoadingFinish: _propTypes.default.func,
  onLoadingStart: _propTypes.default.func
});

_defineProperty(Switch, "defaultProps", {
  loading: null,
  loadingAll: false,
  onLoadingFinish: f => f,
  onLoadingStart: f => f
});

_defineProperty(Switch, "contextTypes", {
  router: _propTypes.default.shape({
    history: _propTypes.default.shape({
      push: _propTypes.default.func.isRequired
    }).isRequired
  }).isRequired
});